<?php
date_default_timezone_set("Asia/Taipei");
require_once __DIR__ . '/../vendor/Autoload.php';

use vendor\DB;
use vendor\Router;
use app\Middleware\AuthMiddleware;

class Main
{
    static function run()
    {
        $conf =  parse_ini_file(__DIR__ . '/../vendor/.env');
        DB::$dbHost = $conf['dbHost'];
        DB::$dbName = $conf['dbName'];
        DB::$dbUser = $conf['dbUser'];
        DB::$dbPassword = $conf['dbPass'];

        if (isset($_GET['action']))
            $action = $_GET['action'];
        else
            $action = "no_action";

        //檢查帳密(以後說明)

        $response = $responseToken = AuthMiddleware::checkToken();

        if ($responseToken['status'] == 200) {
            if ($action != "no_action") {
                $router = new Router();
                require_once __DIR__ . "/../routes/index.php";
                $isGranted = AuthMiddleware::checkPerms($action);
                
                if($isGranted){
                    $response = $router->run($action);
                }else{
                    $response['status'] = 403;
                    $response['message'] = "Access denied(沒有權限執行此動作)";
                }
                // $response = $router->run($action);
                $response['token'] = $responseToken['token'];
            }
        } else {
            switch ($action) {
                case 'doLogin':
                    $response = AuthMiddleware::doLogin();
                    break;
                case 'newMember':
                    $router = new Router();
                    require_once __DIR__ . "/../routes/index.php";
                    $response = $router->run($action);
                    break;
                default:
                    break;
            }
        }
        // echo json_encode($response);

        //判斷權限(以後說明)

        if (isset($response)) {
            header('Content-Type: application/json; charset=utf-8');
            echo json_encode($response);
        } else {
            header('HTTP/1.1 500 Internal Server Error');
        }
    }
}
